// Generated by ParserBuilder @ 17/04/2002 5:09:34 PM

unit ProdCheck2Scanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib, Dialogs;

const
  BlkSize = 16384;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..31] of ^TBufBlock;
  TStartTable = array [0..255] of Integer;
  TGetCH = procedure(pos: longint; var retCh: char) of object;
  TCocoErrorProc = procedure(nr, line, col: Integer; pos: Integer) of object;

type
  TProdCheck2Scanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: Integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: Integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: Integer;
    Fpos: Integer;
    Fcol: Integer;
    FnextCol: Integer;
    FnextPos: Integer;
    Flen: Integer;
    FnextLine: Integer;
    Fline: Integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: Integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar: char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: Integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: Integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: Integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar: char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: Integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: Integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: Integer read Flen write Flen;      (*length of current symbol*)
    property pos: Integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: Integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: Integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: Integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: Integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: Integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 24; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

procedure TProdCheck2Scanner.CapChAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

procedure TProdCheck2Scanner.CharAt(pos: longint; var retChar: char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TProdCheck2Scanner.Comment: boolean;
begin
  Comment := False;
end;


procedure TProdCheck2Scanner.Err(nr, line, col, pos: Integer);
begin
  INC(Ferrors)
end;

procedure TProdCheck2Scanner.Get(var sym: Integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc: char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q, cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  var 
    cc: char;
  begin
    CurrentCh(bp0, cc);
    case cc of
    
      'A': if Equal('ANY') then 
        begin 
          sym := 14; 
        end;
    
      'P': if Equal('PRODUCTIONS') then 
        begin 
          sym := 5; 
        end;
    
      'S': if Equal('SYNC') then 
        begin 
          sym := 15; 
        end;
    
      'W': if Equal('WEAK') then 
        begin 
          sym := 9; 
        end;
    
      else 
      begin 
      end
    end
  end;
begin (*Get*)
  while (ch = ' ') or
        
    ((ch >= CHR(9)) and (ch <= CHR(10)) or
        
    (ch = CHR(13))) do NextCh;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
      1: if ((ch >= '0') and (ch <= '9') or
             
          (ch >= 'A') and (ch <= 'Z') or
             
          (ch = '_')) then 
        begin            
        end 
        else 
        begin 
          sym := 1; 
          CheckLiteral; 
          EXIT; 
        end;
     
      2: 
      begin 
        sym := 2; 
        EXIT; 
      end;
     
      3: 
      begin 
        sym := 3; 
        EXIT; 
      end;
     
      4: if ((ch >= '0') and (ch <= '9')) then 
        begin            
        end 
        else 
        begin 
          sym := 4; 
          EXIT; 
        end;
     
      5: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '!') or
             
          (ch >= '#')) then 
        begin            
        end 
        else if ((ch = CHR(10)) or
                
          (ch = CHR(13))) then 
        begin 
          state := 3; 
        end 
        else if (ch = '"') then 
        begin 
          state := 2; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      6: if ((ch = CHR(0)) or
             
          (ch >= ' ') and (ch <= '&') or
             
          (ch >= '(')) then 
        begin            
        end 
        else if ((ch = CHR(10)) or
                
          (ch = CHR(13))) then 
        begin 
          state := 3; 
        end 
        else if (ch = CHR(39)) then 
        begin 
          state := 2; 
        end 
        else 
        begin 
          sym := no_Sym; 
          EXIT; 
        end;
     
      7: 
      begin 
        sym := 6; 
        EXIT; 
      end;
     
      8: if (ch = '>') then 
        begin 
          state := 17; 
        end 
        else if (ch = ')') then 
        begin 
          state := 19; 
        end 
        else 
        begin 
          sym := 7; 
          EXIT; 
        end;
     
      9: 
      begin 
        sym := 8; 
        EXIT; 
      end;
     
      10: if (ch = '.') then 
        begin 
          state := 18; 
        end 
        else 
        begin 
          sym := 10; 
          EXIT; 
        end;
     
      11: 
      begin 
        sym := 11; 
        EXIT; 
      end;
     
      12: 
      begin 
        sym := 12; 
        EXIT; 
      end;
     
      13: 
      begin 
        sym := 13; 
        EXIT; 
      end;
     
      14: if (ch = '.') then 
        begin 
          state := 16; 
        end 
        else 
        begin 
          sym := 16; 
          EXIT; 
        end;
     
      15: 
      begin 
        sym := 17; 
        EXIT; 
      end;
     
      16: 
      begin 
        sym := 18; 
        EXIT; 
      end;
     
      17: 
      begin 
        sym := 19; 
        EXIT; 
      end;
     
      18: 
      begin 
        sym := 20; 
        EXIT; 
      end;
     
      19: 
      begin 
        sym := 21; 
        EXIT; 
      end;
     
      20: 
      begin 
        sym := 22; 
        EXIT; 
      end;
     
      21: 
      begin 
        sym := 23; 
        EXIT; 
      end;
     
      22: 
      begin 
        sym := 0; 
        ch := #0; 
        DEC(bp); 
        EXIT 
      end;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TProdCheck2Scanner.GetName(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S, Len);
  while i <= len do
  begin
    CurrentCh(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TProdCheck2Scanner.GetString(pos, len: Integer; var s: string);
var
  i: integer;
  p: longint;
  cc: char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S, len);
  while i <= len do
  begin
    CharAt(p, cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TProdCheck2Scanner.NextCh;
  (* Return global variable ch *)
var 
  cc: char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp, cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TProdCheck2Scanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: integer;
begin (*assert: src has been opened*)
  //  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
    //    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TProdCheck2Scanner.Create;
begin
  inherited;
  lst := TStringStream.Create('');
  src := nil;
  CurrentCh := CapChAt;
  
  start[0] := 22; 
  start[1] := 23; 
  start[2] := 23; 
  start[3] := 23; 
  
  start[4] := 23; 
  start[5] := 23; 
  start[6] := 23; 
  start[7] := 23; 
  
  start[8] := 23; 
  start[9] := 23; 
  start[10] := 23; 
  start[11] := 23; 
  
  start[12] := 23; 
  start[13] := 23; 
  start[14] := 23; 
  start[15] := 23; 
  
  start[16] := 23; 
  start[17] := 23; 
  start[18] := 23; 
  start[19] := 23; 
  
  start[20] := 23; 
  start[21] := 23; 
  start[22] := 23; 
  start[23] := 23; 
  
  start[24] := 23; 
  start[25] := 23; 
  start[26] := 23; 
  start[27] := 23; 
  
  start[28] := 23; 
  start[29] := 23; 
  start[30] := 23; 
  start[31] := 23; 
  
  start[32] := 23; 
  start[33] := 23; 
  start[34] := 5; 
  start[35] := 23; 
  
  start[36] := 23; 
  start[37] := 23; 
  start[38] := 23; 
  start[39] := 6; 
  
  start[40] := 10; 
  start[41] := 11; 
  start[42] := 23; 
  start[43] := 23; 
  
  start[44] := 23; 
  start[45] := 23; 
  start[46] := 8; 
  start[47] := 23; 
  
  start[48] := 4; 
  start[49] := 4; 
  start[50] := 4; 
  start[51] := 4; 
  
  start[52] := 4; 
  start[53] := 4; 
  start[54] := 4; 
  start[55] := 4; 
  
  start[56] := 4; 
  start[57] := 4; 
  start[58] := 23; 
  start[59] := 23; 
  
  start[60] := 14; 
  start[61] := 7; 
  start[62] := 15; 
  start[63] := 23; 
  
  start[64] := 23; 
  start[65] := 1; 
  start[66] := 1; 
  start[67] := 1; 
  
  start[68] := 1; 
  start[69] := 1; 
  start[70] := 1; 
  start[71] := 1; 
  
  start[72] := 1; 
  start[73] := 1; 
  start[74] := 1; 
  start[75] := 1; 
  
  start[76] := 1; 
  start[77] := 1; 
  start[78] := 1; 
  start[79] := 1; 
  
  start[80] := 1; 
  start[81] := 1; 
  start[82] := 1; 
  start[83] := 1; 
  
  start[84] := 1; 
  start[85] := 1; 
  start[86] := 1; 
  start[87] := 1; 
  
  start[88] := 1; 
  start[89] := 1; 
  start[90] := 1; 
  start[91] := 12; 
  
  start[92] := 23; 
  start[93] := 13; 
  start[94] := 23; 
  start[95] := 1; 
  
  start[96] := 23; 
  start[97] := 23; 
  start[98] := 23; 
  start[99] := 23; 
  
  start[100] := 23; 
  start[101] := 23; 
  start[102] := 23; 
  start[103] := 23; 
  
  start[104] := 23; 
  start[105] := 23; 
  start[106] := 23; 
  start[107] := 23; 
  
  start[108] := 23; 
  start[109] := 23; 
  start[110] := 23; 
  start[111] := 23; 
  
  start[112] := 23; 
  start[113] := 23; 
  start[114] := 23; 
  start[115] := 23; 
  
  start[116] := 23; 
  start[117] := 23; 
  start[118] := 23; 
  start[119] := 23; 
  
  start[120] := 23; 
  start[121] := 23; 
  start[122] := 23; 
  start[123] := 20; 
  
  start[124] := 9; 
  start[125] := 21; 
  start[126] := 23; 
  start[127] := 23; 
  
  start[128] := 23; 
  start[129] := 23; 
  start[130] := 23; 
  start[131] := 23; 
  
  start[132] := 23; 
  start[133] := 23; 
  start[134] := 23; 
  start[135] := 23; 
  
  start[136] := 23; 
  start[137] := 23; 
  start[138] := 23; 
  start[139] := 23; 
  
  start[140] := 23; 
  start[141] := 23; 
  start[142] := 23; 
  start[143] := 23; 
  
  start[144] := 23; 
  start[145] := 23; 
  start[146] := 23; 
  start[147] := 23; 
  
  start[148] := 23; 
  start[149] := 23; 
  start[150] := 23; 
  start[151] := 23; 
  
  start[152] := 23; 
  start[153] := 23; 
  start[154] := 23; 
  start[155] := 23; 
  
  start[156] := 23; 
  start[157] := 23; 
  start[158] := 23; 
  start[159] := 23; 
  
  start[160] := 23; 
  start[161] := 23; 
  start[162] := 23; 
  start[163] := 23; 
  
  start[164] := 23; 
  start[165] := 23; 
  start[166] := 23; 
  start[167] := 23; 
  
  start[168] := 23; 
  start[169] := 23; 
  start[170] := 23; 
  start[171] := 23; 
  
  start[172] := 23; 
  start[173] := 23; 
  start[174] := 23; 
  start[175] := 23; 
  
  start[176] := 23; 
  start[177] := 23; 
  start[178] := 23; 
  start[179] := 23; 
  
  start[180] := 23; 
  start[181] := 23; 
  start[182] := 23; 
  start[183] := 23; 
  
  start[184] := 23; 
  start[185] := 23; 
  start[186] := 23; 
  start[187] := 23; 
  
  start[188] := 23; 
  start[189] := 23; 
  start[190] := 23; 
  start[191] := 23; 
  
  start[192] := 23; 
  start[193] := 23; 
  start[194] := 23; 
  start[195] := 23; 
  
  start[196] := 23; 
  start[197] := 23; 
  start[198] := 23; 
  start[199] := 23; 
  
  start[200] := 23; 
  start[201] := 23; 
  start[202] := 23; 
  start[203] := 23; 
  
  start[204] := 23; 
  start[205] := 23; 
  start[206] := 23; 
  start[207] := 23; 
  
  start[208] := 23; 
  start[209] := 23; 
  start[210] := 23; 
  start[211] := 23; 
  
  start[212] := 23; 
  start[213] := 23; 
  start[214] := 23; 
  start[215] := 23; 
  
  start[216] := 23; 
  start[217] := 23; 
  start[218] := 23; 
  start[219] := 23; 
  
  start[220] := 23; 
  start[221] := 23; 
  start[222] := 23; 
  start[223] := 23; 
  
  start[224] := 23; 
  start[225] := 23; 
  start[226] := 23; 
  start[227] := 23; 
  
  start[228] := 23; 
  start[229] := 23; 
  start[230] := 23; 
  start[231] := 23; 
  
  start[232] := 23; 
  start[233] := 23; 
  start[234] := 23; 
  start[235] := 23; 
  
  start[236] := 23; 
  start[237] := 23; 
  start[238] := 23; 
  start[239] := 23; 
  
  start[240] := 23; 
  start[241] := 23; 
  start[242] := 23; 
  start[243] := 23; 
  
  start[244] := 23; 
  start[245] := 23; 
  start[246] := 23; 
  start[247] := 23; 
  
  start[248] := 23; 
  start[249] := 23; 
  start[250] := 23; 
  start[251] := 23; 
  
  start[252] := 23; 
  start[253] := 23; 
  start[254] := 23; 
  start[255] := 23; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TProdCheck2Scanner.Destroy;
begin
  if (src <> nil) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TProdCheck2Scanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 31 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end.
