// Generated by ParserBuilder @ 12/04/2002 2:29:25 PM

unit SimpleSyntaxCheckerParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, pbStrLib,
  SimpleSyntaxCheckerScanner, SimpleSyntaxCheckerG (* Symbol Constants *);


const
  maxT = 11;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;



type
  TSimpleSyntaxCheckerParser = class(TSimpleSyntaxCheckerScanner)
  private
    FSuccessful: boolean;
    //-----------------------------------------------------
    FBracketList: TStringList;
    fOutputStream: TStringStream;
    fCollectStart: Integer;
    fCollectLength: Integer;
    fInBracket: boolean;
    procedure Init;
    procedure Final;
    //    function CalcLength: Integer;
    //    procedure SetStart;
    //    function CopySourceToCurrent: string;
    procedure WriteStr(S: string);
    //    function GetLexString: string;
    procedure ReportError(nr, line, col, pos: Integer);
    function TextOK: boolean;
    procedure WriteCurrentBracket(const brktID: Integer);
    //-----------------------------------------------------

    procedure PerformGet;
    procedure SynError(errNo: Integer);
    //    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    //    procedure Expect(n: Integer);
    //    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _TextBlock;
    procedure _SimpleSyntaxChecker;


  protected
    
  public
    
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    
  end;

implementation

var
  symSet: array [0..0] of TSymbolSet;
  errDist: integer;
  sym: integer;

  //procedure TSimpleSyntaxCheckerParser.SetStart;
  //begin
  //  fCollectStart := nextPos + 1;
  //end;

procedure TSimpleSyntaxCheckerParser.Init;
begin
  fOutputStream.Size := 0;
  fCollectStart := 0;
  fCollectLength := 0;
  lst.Size := 0;
  FBracketList.Clear;
  fInBracket := False;
end;

//function TSimpleSyntaxCheckerParser.CopySourceToCurrent: string;
//begin
//  CalcLength;
//  Result := Copy(src.DataString, FCollectStart, fCollectLength);
//end;

//function TSimpleSyntaxCheckerParser.CalcLength: Integer;
//begin
//  Result := nextPos - fCollectStart + 1;
//  fCollectLength := Result;
//end;

procedure TSimpleSyntaxCheckerParser.Final;
begin
  if Errors > 0 then
    lst.WriteString('Errors found - mismatched bracketting { ( [ ] ) }');
  lst.WriteString(#13#10 + fOutputStream.DataString);
  if (fBracketList.Count = 0) then
    lst.WriteString(#13#10 + fBracketList.Text);
  fOutputStream.Size := 0;
end;

procedure TSimpleSyntaxCheckerParser.WriteStr(S: string);
begin
  fOutputStream.WriteBuffer(S[1], length(S));
end;

//function TSimpleSyntaxCheckerParser.GetLexString: string;
//begin
//  LexString(Result);
//end;

procedure TSimpleSyntaxCheckerParser.ReportError(nr, line, col, pos: Integer);
var
  S, S1: string;
  SL: TStringList;
begin
  case nr of
    {$I  SimpleSyntaxChecker.err}
  end; // Case
  S := S + CRLF + 'Line ' + IntToStr(line) + CRLF + 'Column ' + IntToStr(col) + CRLF;
  SL := TStringList.Create;
  SL.Text := src.DataString;
  S1 := SL[Line - 1];
  SL.Free;
  Insert(' >*ERROR*> ', S1, Col - 1);
  Inc(fErrors);
  WriteStr(S + S1);
end;

function TSimpleSyntaxCheckerParser.TextOK: boolean;
var 
  idx: integer;
begin
  // verify that all is well by analysing the BracketList
  for idx := 0 to fBracketLIst.Count - 1 do
    if (Length(fBracketList[idx]) <> 2) then
    begin
      inc(fErrors);
      //   WriteStr(#13#10+'Missing punctuation in bracketted section #'+ IntToStr(idx+1));
    end
  else
  begin
    if (fBracketList[idx][1] = '(') and (fBracketList[idx][2] <> ')') or
      (fBracketList[idx][1] = '[') and (fBracketList[idx][2] <> ']') or
      (fBracketList[idx][1] = '{') and (fBracketList[idx][2] <> '}') or
      (fBracketList[idx][1] = '<') and (fBracketList[idx][2] <> '>') then
    begin
      inc(fErrors);
      WriteStr('Mismatched enclosures ' + fBracketList[idx][1] + ' AND ' +
        fBracketList[idx][2]);
    end;
  end;

  Result := fErrors = 0;
  FBracketList.Clear;
  fInBracket := False;
end;

procedure TSimpleSyntaxCheckerParser.WriteCurrentBracket(const brktID: Integer);
var 
  idx: integer;
begin
  // if the bracket is an opener, then add it to the string list
  // if the bracket is a closer, then concatenate it with the last opener found
  // at the end, there should be no bracket-pairs that are mismatched
  // and there should be no single brackets

  case brktID of
    1: 
    begin 
      FBracketList.Add('('); 
      fInBracket := True; 
    end;
    2: 
    begin   
      FBracketList.Add('['); 
      fInBracket := True; 
    end;
    3: 
    begin   
      FBracketList.Add('{'); 
      fInBracket := True; 
    end;
    4: 
    begin
      for idx := FBracketList.Count - 1 downto 0 do
        if FBracketList[idx] = '(' then
        begin
          FBracketList[idx] := '()';
          fInBracket := False;
          Exit;
        end;
      FBracketList.Add(')');
      fInBracket := False;
    end;
    5: 
    begin  
      if FBracketList.Count > 0 then
        for idx := FBracketList.Count - 1 downto 0 do
          if FBracketList[idx] = '[' then
          begin
            FBracketList[idx] := '[]';
            fInBracket := False;
            Exit;
          end;
      FBracketList.Add(']');
      fInBracket := False;
    end;
    6: 
    begin
      for idx := FBracketList.Count - 1 downto 0 do
        if FBracketList[idx] = '{' then
        begin
          FBracketList[idx] := '{}';
          fInBracket := False;
          Exit;
        end;
      FBracketList.Add('}');
      fInBracket := False;
    end;
    7: 
    begin   
      FBracketList.Add('<');  
      fInBracket := True; 
    end;
    8:
    begin
      for idx := FBracketList.Count - 1 downto 0 do
        if FBracketList[idx] = '<' then
        begin
          FBracketList[idx] := '<>';
          fInBracket := False;
          Exit;
        end;
      FBracketList.Add('>');
      fInBracket := False;
    end;
  end; // Case
end;




 { TSimpleSyntaxCheckerParser - Generated Methods }
//procedure TSimpleSyntaxCheckerParser.SemError(errNo: Integer);
//begin
//  if errDist >= minErrDist then
//  begin
//    Error(errNo, line, col, pos);
//  end;
//  errDist := 0;
//end;

procedure TSimpleSyntaxCheckerParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TSimpleSyntaxCheckerParser.PerformGet;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin        
    end;
  until sym <= maxT
  end;

function TSimpleSyntaxCheckerParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TSimpleSyntaxCheckerParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

//procedure TSimpleSyntaxCheckerParser.Expect(n: Integer);
//begin
//  if Sym = n then PerformGet
//  else
//    SynError(n);
//end;
//
//procedure TSimpleSyntaxCheckerParser.ExpectWeak(n, follow: Integer);
//begin
//  if Sym = n then PerformGet
//  else
//  begin
//    SynError(n);
//    while not _In(symSet[follow], Sym) do PerformGet;
//  end
//end;

function TSimpleSyntaxCheckerParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TSimpleSyntaxCheckerParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TSimpleSyntaxCheckerParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TSimpleSyntaxCheckerParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TSimpleSyntaxCheckerParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TSimpleSyntaxCheckerParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TSimpleSyntaxCheckerParser._TextBlock;
begin
  case sym of
    stringSym: 
    begin
      PerformGet;
    end;
    _lparenSym: 
    begin
      PerformGet;
      WriteCurrentBracket(1);
    end;
    _lbrackSym: 
    begin
      PerformGet;
      WriteCurrentBracket(2);
    end;
    _lbraceSym: 
    begin
      PerformGet;
      WriteCurrentBracket(3);
    end;
    _lparen_pointSym: 
    begin
      PerformGet;
      WriteCurrentBracket(7);
    end;
    identSym: 
    begin
      PerformGet;
    end;
    _rbraceSym: 
    begin
      PerformGet;
      WriteCurrentBracket(6);
    end;
    _rbrackSym: 
    begin
      PerformGet;
      WriteCurrentBracket(5);
    end;
    _rparenSym: 
    begin
      PerformGet;
      WriteCurrentBracket(4);
    end;
    _point_rparenSym: 
    begin
      PerformGet;
      WriteCurrentBracket(8);
    end;
    else 
    begin 
      SynError(12);
    end;
  end;
end;

procedure TSimpleSyntaxCheckerParser._SimpleSyntaxChecker;
begin
  Init;;
  while (sym < 16) (* prevent range error *) and
    (sym in [identSym, stringSym, _lparenSym, _lbrackSym, _lbraceSym, 
    _lparen_pointSym, _rbraceSym, _rbrackSym, _rparenSym, 
    _point_rparenSym]) do 
  begin
    _TextBlock;
  end;
  TextOK;
  Final;;
end;



procedure TSimpleSyntaxCheckerParser.Parse;
begin
  _Reset; 
  PerformGet;
  _SimpleSyntaxChecker;
end;

destructor TSimpleSyntaxCheckerParser.Destroy;
begin
  fOutputStream.Free;
  FBracketList.Free;

  inherited;
end;

constructor TSimpleSyntaxCheckerParser.Create;
begin
  inherited;
  fOutputStream := TStringStream.Create('');
  Error := ReportError;
  FBracketList := TStringList.Create;

  errDist := minErrDist;
  symSet[0, 0] := [];
end;


end.
