// Generated by ParserBuilder @ 20/04/2002 9:40:10 PM

unit ParserUnitImportParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, pbStrLib, ParserUnitImportScanner;


const
  maxT = 21;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;

  // If you have edited a parser file in the Delphi IDE,
  // it may be out-of-sync with the ATG file and the
  // changes may be overwritten next time you regenerate
  // the parser.
  // This parser lets you import certain changes back
  // into ParserBuilder, provided you have not overwritten
  // the special tags placed in the pbParser.frm frame file.
  //These tags appear in the generated Pascal.
  // Provided you place your edits between the open and close tags for any section
  //  of the unit, your changes can be imported into ParserBuilder.
  // It only imports Private, Protected, Public, Published,
  //  Arbitrary Source, Create and Destroy code. It does
  // not bring in the Uses and Global sections.
  // It will probably never import the source produced
  // via Semantic Actions inside an ATG file.


type
  TParserUnitImportParser = class(TParserUnitImportScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    fOutputStream: TStringStream;
    fCollectStart: Integer;
    fCollectLength: Integer;
    FPublishedSection: string;
    FArbitrarySourceSection: string;
    FGlobalSection: string;
    FPrivateSection: string;
    FCreateSection: string;
    FProtectedSection: string;
    FDestroySection: string;
    FErrorsSection: string;
    FPublicSection: string;
    FUsesSection: string;
    procedure Init;
    procedure Final;
    function CalcLength: Integer;
    procedure SetStart;
    function CopySourceToCurrent: string;
    procedure WriteStr(S: string);
    procedure ReportError(nr, line, col, pos: Integer);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _CreateSection;
    procedure _DestroySection;
    procedure _ArbitraryCodeSection;
    procedure _PublishedSection;
    procedure _PublicSection;
    procedure _ProtectedSection;
    procedure _PrivateSection;
    procedure _GlobalSection;
    procedure _UsesSection;
    procedure _PascalChunks;
    procedure _ParserUnitImport;


  protected
    {PBPROTECTED}
    procedure SetArbitrarySourceSection(const Value: string);
    procedure SetCreateSection(const Value: string);
    procedure SetDestroySection(const Value: string);
    procedure SetErrorsSection(const Value: string);
    procedure SetGlobalSection(const Value: string);
    procedure SetPrivateSection(const Value: string);
    procedure SetProtectedSection(const Value: string);
    procedure SetPublicSection(const Value: string);
    procedure SetPublishedSection(const Value: string);

    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    {PBPUBLISHED}
    property PrivateSection: string read FPrivateSection write SetPrivateSection;
    property ProtectedSection: string read FProtectedSection write SetProtectedSection;
    property PublicSection: string read FPublicSection write SetPublicSection;
    property PublishedSection: string read FPublishedSection write SetPublishedSection;
    property ArbitrarySourceSection: string   
      read FArbitrarySourceSection write SetArbitrarySourceSection;
    property CreateSection: string read FCreateSection write SetCreateSection;
    property DestroySection: string read FDestroySection write SetDestroySection;
    property ErrorsSection: string read FErrorsSection write SetErrorsSection;
    property GlobalSection: string read FGlobalSection write SetGlobalSection;
    property UsesSection: string read FUsesSection write FUsesSection;

    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..19] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

  {PBARBITRARYSOURCE}


procedure TParserUnitImportParser.SetStart;
begin
  fCollectStart := nextPos + 1;
end;

procedure TParserUnitImportParser.Init;
begin
  fOutputStream.Size := 0;
  fCollectStart := 0;
  fCollectLength := 0;
  lst.Size := 0;
end;

function TParserUnitImportParser.CopySourceToCurrent: string;
begin
  CalcLength;
  Result := Copy(src.DataString, FCollectStart, fCollectLength);
end;

function TParserUnitImportParser.CalcLength: Integer;
begin
  Result := nextPos - fCollectStart + 1;
  fCollectLength := Result;
end;

procedure TParserUnitImportParser.Final;
begin
  if Errors = 0 then
    lst.WriteString('No Errors');
  lst.WriteString(fOutputStream.DataString);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('USES' +CRLF);
  // lst.WriteString(UsesSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('GLOBAL' +CRLF);
  // lst.WriteString(GlobalSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('PRIVATE' +CRLF);
  // lst.WriteString(PrivateSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('PROTECTED' +CRLF);
  // lst.WriteString(ProtectedSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('PUBLIC' +CRLF);
  // lst.WriteString(PublicSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('PUBLISHED' +CRLF);
  // lst.WriteString(ProtectedSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('CREATE' +CRLF);
  // lst.WriteString(CreateSection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  // lst.WriteString('DESTROY' +CRLF);
  // lst.WriteString(DestroySection+CRLF);
  // lst.WriteString('----------------------------------' +CRLF);
  fOutputStream.Size := 0;
end;

procedure TParserUnitImportParser.WriteStr(S: string);
begin
  fOutputStream.WriteBuffer(S[1], length(S));
end;

procedure TParserUnitImportParser.ReportError(nr, line, col, pos: Integer);
var
  S, S1: string;
  SL: TStringList;
begin
  case nr of
    {$I  ParserUnitImport.err}
  end; // Case
  S := CRLF + S + CRLF + 'Line ' + IntToStr(line) + CRLF + 'Column ' + IntToStr(col) + CRLF;
  SL := TStringList.Create;
  SL.Text := src.DataString;
  S1 := SL[Line - 1];
  SL.Free;
  Insert(' >*ERROR*> ', S1, Col - 1);
  Inc(fErrors);
  WriteStr(S + S1);
end;

procedure TParserUnitImportParser.SetArbitrarySourceSection(const Value: string);
begin
  FArbitrarySourceSection := Value;
end;

procedure TParserUnitImportParser.SetCreateSection(const Value: string);
begin
  FCreateSection := Value;
end;

procedure TParserUnitImportParser.SetDestroySection(const Value: string);
begin
  FDestroySection := Value;
end;

procedure TParserUnitImportParser.SetErrorsSection(const Value: string);
begin
  FErrorsSection := Value;
end;

procedure TParserUnitImportParser.SetGlobalSection(const Value: string);
begin
  FGlobalSection := Value;
end;

procedure TParserUnitImportParser.SetPrivateSection(const Value: string);
begin
  FPrivateSection := Value;
end;

procedure TParserUnitImportParser.SetProtectedSection(const Value: string);
begin
  FProtectedSection := Value;
end;

procedure TParserUnitImportParser.SetPublicSection(const Value: string);
begin
  FPublicSection := Value;
end;

procedure TParserUnitImportParser.SetPublishedSection(const Value: string);
begin
  FPublishedSection := Value;
end;




{ENDPBARBITRARYSOURCE}

 { TParserUnitImportParser - Generated Methods below}

procedure TParserUnitImportParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TParserUnitImportParser.PerformGet;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin     
    end;
  until sym <= maxT
  end;

function TParserUnitImportParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TParserUnitImportParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TParserUnitImportParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

function TParserUnitImportParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TParserUnitImportParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TParserUnitImportParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TParserUnitImportParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TParserUnitImportParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TParserUnitImportParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TParserUnitImportParser._CreateSection;
begin
  Expect(17);
  SetStart;
  while _In(symSet[1], sym) do 
  begin
    PerformGet;
  end;
  CREATESection := CopySourceToCurrent;
  Expect(18);
end;

procedure TParserUnitImportParser._DestroySection;
begin
  Expect(19);
  SetStart;
  while _In(symSet[2], sym) do 
  begin
    PerformGet;
  end;
  DestroySection := CopySourceToCurrent;
  Expect(20);
end;

procedure TParserUnitImportParser._ArbitraryCodeSection;
begin
  Expect(15);
  SetStart;
  while _In(symSet[3], sym) do 
  begin
    PerformGet;
  end;
  ArbitrarySourceSection := CopySourceToCurrent;
  Expect(16);
end;

procedure TParserUnitImportParser._PublishedSection;
begin
  Expect(11);
  SetStart;
  while _In(symSet[4], sym) do 
  begin
    PerformGet;
  end;
  PublishedSection := CopySourceToCurrent;
  Expect(12);
end;

procedure TParserUnitImportParser._PublicSection;
begin
  Expect(9);
  SetStart;
  while _In(symSet[5], sym) do 
  begin
    PerformGet;
  end;
  PublicSection := CopySourceToCurrent;
  Expect(10);
end;

procedure TParserUnitImportParser._ProtectedSection;
begin
  Expect(7);
  SetStart;
  while _In(symSet[6], sym) do 
  begin
    PerformGet;
  end;
  ProtectedSection := CopySourceToCurrent;
  Expect(8);
end;

procedure TParserUnitImportParser._PrivateSection;
begin
  Expect(5);
  SetStart;
  while _In(symSet[7], sym) do 
  begin
    PerformGet;
  end;
  PrivateSection := CopySourceToCurrent;
  Expect(6);
end;

procedure TParserUnitImportParser._GlobalSection;
begin
  Expect(13);
  SetStart;
  while _In(symSet[8], sym) do 
  begin
    PerformGet;
  end;
  GlobalSection := CopySourceToCurrent;
  Expect(14);
end;

procedure TParserUnitImportParser._UsesSection;
begin
  Expect(3);
  SetStart;
  while _In(symSet[9], sym) do 
  begin
    PerformGet;
  end;
  UsesSection := CopySourceToCurrent;
  Expect(4);
end;

procedure TParserUnitImportParser._PascalChunks;
begin
  while _In(symSet[10], sym) do 
  begin
    PerformGet;
  end;
  _UsesSection;
  while _In(symSet[11], sym) do 
  begin
    PerformGet;
  end;
  _GlobalSection;
  while _In(symSet[12], sym) do 
  begin
    PerformGet;
  end;
  _PrivateSection;
  while _In(symSet[13], sym) do 
  begin
    PerformGet;
  end;
  _ProtectedSection;
  while _In(symSet[14], sym) do 
  begin
    PerformGet;
  end;
  _PublicSection;
  while _In(symSet[15], sym) do 
  begin
    PerformGet;
  end;
  _PublishedSection;
  while _In(symSet[16], sym) do 
  begin
    PerformGet;
  end;
  _ArbitraryCodeSection;
  while _In(symSet[17], sym) do 
  begin
    PerformGet;
  end;
  _DestroySection;
  while _In(symSet[18], sym) do 
  begin
    PerformGet;
  end;
  _CreateSection;
end;

procedure TParserUnitImportParser._ParserUnitImport;
begin
  Init;
  _PascalChunks;
  while _In(symSet[19], sym) do 
  begin
    PerformGet;
  end;
  Expect(0);
  Final;
end;



procedure TParserUnitImportParser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
  else 
  begin    
    _Reset; 
    PerformGet;
    _ParserUnitImport;
  end;
end;

destructor TParserUnitImportParser.Destroy;
begin
  {PBDESTROY}
  fOutputStream.Free;

  {ENDPBDESTROY}
  inherited;
end;

constructor TParserUnitImportParser.Create;
begin
  inherited;
  {PBCREATE}
  fOutputStream := TStringStream.Create('');
  Error := ReportError;

  {ENDPBCREATE}
  errDist := minErrDist;
  symSet[0, 0] := [15];
  symSet[0, 1] := [];
  symSet[1, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[1, 1] := [0, 1, 3, 4, 5];
  symSet[2, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[2, 1] := [0, 1, 2, 3, 5];
  symSet[3, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[3, 1] := [1, 2, 3, 4, 5];
  symSet[4, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14];
  symSet[4, 1] := [0, 1, 2, 3, 4, 5];
  symSet[5, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14];
  symSet[5, 1] := [0, 1, 2, 3, 4, 5];
  symSet[6, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14];
  symSet[6, 1] := [0, 1, 2, 3, 4, 5];
  symSet[7, 0] := [0, 1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[7, 1] := [0, 1, 2, 3, 4, 5];
  symSet[8, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13];
  symSet[8, 1] := [0, 1, 2, 3, 4, 5];
  symSet[9, 0] := [0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[9, 1] := [0, 1, 2, 3, 4, 5];
  symSet[10, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[10, 1] := [0, 1, 2, 3, 4, 5];
  symSet[11, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14];
  symSet[11, 1] := [0, 1, 2, 3, 4, 5];
  symSet[12, 0] := [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[12, 1] := [0, 1, 2, 3, 4, 5];
  symSet[13, 0] := [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13, 14];
  symSet[13, 1] := [0, 1, 2, 3, 4, 5];
  symSet[14, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 11, 12, 13, 14];
  symSet[14, 1] := [0, 1, 2, 3, 4, 5];
  symSet[15, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 14];
  symSet[15, 1] := [0, 1, 2, 3, 4, 5];
  symSet[16, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[16, 1] := [0, 1, 2, 3, 4, 5];
  symSet[17, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[17, 1] := [0, 1, 2, 4, 5];
  symSet[18, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[18, 1] := [0, 2, 3, 4, 5];
  symSet[19, 0] := [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[19, 1] := [0, 1, 2, 3, 4, 5];
end;


end.
